variables:
  
  # Used in :
  #   - Jobs/Build-Docker.gitlab-ci.yml
  DOCKER_IMAGE: docker:24.0.5
  DOCKER_SERVICE: docker:24.0.5-dind

  # Used in: 
  #   - Jobs/Package.gitlab-ci.yml
  HELM_PROJECT_NAME: $CI_PROJECT_NAME
  
  # Used in: 
  #   - Jobs/Build-Docker.gitlab-ci.yml and 
  #   - Jobs/Container-Scanning.gitlab-ci.yml
  IMAGE_NAME: $CI_REGISTRY_IMAGE/$CI_COMMIT_REF_NAME
  
  # Used in: 
  #   - Jobs/Code-Intelligence.gitlab-ci.yml and  
  JVM_VERSION: 17

  # Used in: 
  #   - Jobs/Build-Java.gitlab-ci.yml
  #   - Jobs/Code-Quality.gitlab-ci.yml
  MAVEN_CLI_OPTS: >-
    --batch-mode
    --errors
    --fail-at-end
    --show-version
    --no-transfer-progress
  MAVEN_IMAGE: maven:3.9.6-eclipse-temurin-17-alpine
  MAVEN_OPTS: >-
    -Dhttps.protocols=TLSv1.2
    -Dmaven.repo.local=$CI_PROJECT_DIR/.m2/repository
    -Dorg.slf4j.simpleLogger.showDateTime=true
    -Djava.awt.headless=true
  
  # Used in: 
  #   - Jobs/Package.gitlab-ci.yml
  PACKAGE_HELM_DIR: helm/${CI_PROJECT_NAME}
  PACKAGE_HELM_PROJECT: gabriel-nigro-labs/infra/packages/helm

  # Set runner
  RUNNER: gitlab-org-docker

  # Used in: 
  #   - Jobs/Code-Quality.gitlab-ci.yml
  SONAR_IMAGE: maven:3.9.6-eclipse-temurin-17-alpine
  SONAR_PROJECT_KEY: gabriel-nigro-portfolio_java-hello-world

  # Used in: 
  #   - Jobs/DAST-Api.gitlab-ci.yml
  FORMAT: openapi
  TARGET_URL: https://java-ci-template-staging.onrender.com/v3/api-docs

  # Set timezone
  TZ: America/Sao_Paulo

stages:
  - build:java
  - build:docker
  - test
  - package

workflow:
  rules:
    - exists:
        - Dockerfile.ci
    
    - exists:
        - pom.xml

include:
- project: 'gabriel-nigro-labs/infra/ci/templates'
  ref: main
  file: 
    - '/Jobs/Build-Docker.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/Build-Docker.gitlab-ci.yml
    - '/Jobs/Build-Java.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/Build-Java.gitlab-ci.yml
    - '/Jobs/Code-Intelligence.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/Code-Intelligence.gitlab-ci.yml
    - '/Jobs/Code-Quality.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/Code-Quality.gitlab-ci.yml
    - '/Jobs/Container-Scanning.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/Container-Scanning.gitlab-ci.yml
    #- '/Jobs/DAST-Api.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/DAST-Api.gitlab-ci.yml
    - '/Jobs/Dependency-Check.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/Dependency-Check.gitlab-ci.yml
    #- '/Jobs/Deploy.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/Deploy.gitlab-ci.yml
    - '/Jobs/Package.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/SAST.gitlab-ci.yml
    #- '/Jobs/SAST.gitlab-ci.yml' # https://gitlab.com/gabriel-nigro/ci-templates/-/blob/main/Jobs/SAST.gitlab-ci.yml